import React, { Component } from 'react';
import FontAwesome from 'react-fontawesome';

export default class AddTestItem extends Component {
  constructor(props){
    super(props);
    this.state = {
      question: '',
      answerCount: [{value: ''},{value: ''}],
    }

  }
  render(){

    return(
      <div className="add-test-item">
        <span className="question-counter">{this.props.questionNumber}.</span>
        <input className ="question-input" value={this.state.question} onInput={this.questionChange} ref="question" type="text" placeholder="enter the question.."/>
        <FontAwesome name="question" className="question-mark" />
        {
          this.state.answerCount.map((item,i)=>{
            return (<div  className="answer-input-wrapper" key={i}><FontAwesome name="circle-o" className="answer-circle"/><input onChange={this.sendData} placeholder="" value={item.value} onInput={(e)=>this.inputChange(i,e)} className ="answer-input" type="text"/><FontAwesome onClick={()=>this.deleteAnswer(i)} name='times' className="icon"/></div>)
          })
        }
        <button type="button" onClick={this.addAnswer}>Add answer</button>
      </div>
    )
  }
  //custom methods
  addAnswer = () => {
    this.setState((prevState,props)=>({answerCount: prevState.answerCount.concat({value: ''})}));
  }
  deleteAnswer = (i) => {
    this.setState((prevState)=>({answerCount: prevState.answerCount.filter((item,index)=>(i!=index))}))
  }
  inputChange = (i,e) => {
    var arr = this.state.answerCount;
    arr[i].value = e.target.value;
    this.setState({answerCount: arr});
    setTimeout(()=>{
        this.props.takeInfo(this.state,this.props.questionNumber);
    },100)
  }
  questionChange = (e) => {
    this.setState({question: e.target.value});
    setTimeout(()=>{
        this.props.takeInfo(this.state,this.props.questionNumber);
    },100)
  }


}
